program ExtractJPEG;

{ Extracts all JPEGs from OPN file }

const MaxArrSize = 64000;
type arrMaxByte = array [ 0 .. MaxArrSize - 1 ] of Byte;
     arr10By = array [ 0 .. 9 ] of Byte;

var InF, OutF : file of Byte;
    InFN, OutFN, NewDir, TStr : string;
    { arrOutF : arrMaxByte; }
    arrTested : arr10By;
    ImgCnt : Integer;
    CurL, i : LongInt;
    TBy : Byte;

function IsJPEGHeader (TStr : arr10By) : boolean;
    const  JPEGHead : arr10By
                    = ($FF, $D8, $FF, $E0, $00, $00, $4A, $46, $49, $46);
    var TBool : Boolean; i : Integer;
  begin
    TBool := False; i := 0;
    repeat
      if (i < 4) or (i > 5) then   { header length can vary }
         if JPEGHead [ i ] <> TStr [ i ] then TBool := True;
      Inc (i);
    until TBool or (i > 9);
    IsJPEGHeader := not TBool;
  end;

procedure AddByte (B : Byte; var TArr : arr10By);
    var i : Integer;
  begin
    for i := 1 to 9 do
        TArr [ i - 1 ] := TArr [ i ];
    TArr [ 9 ] := B;
  end;

function GetOutFN (OFN : string; C : integer) : string;
    var TStr : string; i : integer;
  begin
    Str (C:3, TStr);
    for i := 1 to 3 do
        if TStr [ i ] = ' ' then TStr [ i ] := '0';
    TStr := Copy (OFN, 1, Pos ('.', OFN) - 1) + TStr + '.jpg';
    GEtOutFN := TStr;
  end;

begin
  if ParamCount > 0 then InFN := ParamStr (1)
     else begin
            Write ('Input OPN file-name : ');
            ReadLn (InFN);
          end;
  ImgCnt := 0; CurL := 0;
  Assign (InF, InFN); ReSet (InF);

  for i := 0 to 9 do
      begin
        Read (InF, TBy);
        arrTested [ i ] := TBy;
      end;
  while not (IsJPEGHeader (arrTested) ) do
        begin
          Read (InF, TBy);
          AddByte (TBy, arrTested);
        end;
  { for i := 0 to 9 do arrOutF [ i ] := arrTested [ i ]; }
  CurL := 10;

  NewDir := Copy (InFN, 1, Pos ('.', InFN) - 1);
  MkDir (NewDir); ChDir (NewDir);
  GetDir (0, TStr);
  WriteLn ( '   >>> ', TStr );

  while not EoF (InF) do
        begin
          OutFN := GetOutFN (InFN, ImgCnt);
          Assign (OutF, OutFN); ReWrite (OutF);
          for i := 0 to 9 do Write (OutF, arrTested [ i ]);
          repeat
            if not EoF (InF) then Read (InF, TBy);
            { arrOutF [ CurL ] := TBy; }
            Write (OutF, TBy);
            Inc (CurL);
            AddByte (TBy, arrTested);
          until IsJPEGHeader (arrTested) or EoF (InF);

          if EoF (InF) then Write ('/ ');

          { for i := 0 to (CurL - 10) do Write (OutF, arrOutF [ i ]); }
          Close (OutF);

          Inc (ImgCnt);
          { for i := 0 to 9 do arrOutF [ i ] := arrTested [ i ]; }
          CurL := 10;
          Write ('.');
        end;

  ChDir ('..');

  Close (InF);
  WriteLn ('Done ... extracted ', ImgCnt : 3, ' images', Chr (7) );
  { Write (Chr(7)) is system beep }
end.